#!/usr/bin/env bash

[[ ${BURR_SORT_LOADED:-} -eq 1 ]] && return

# quicksorts positional arguments
# return is in array qsort_ret
qsort() {
   local pivot i smaller=() larger=()
   qsort_ret=()
   (($#==0)) && return 0
   pivot="${1}"
   shift
   for i; do
      if [[ "${i}" < "${pivot}" ]]; then
         smaller+=( "${i}" )
      else
         larger+=( "${i}" )
      fi
   done
   qsort "${smaller[@]}"
   smaller=( "${qsort_ret[@]}" )
   qsort "${larger[@]}"
   larger=( "${qsort_ret[@]}" )
   qsort_ret=( "${smaller[@]}" "$pivot" "${larger[@]}" )
}

BURR_SORT_LOADED=1
